diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.46/src/spectrum/test/three-gpp-channel-test-suite.cc ns-3.47/src/spectrum/test/three-gpp-channel-test-suite.cc
--- ns-3.46/src/spectrum/test/three-gpp-channel-test-suite.cc	2025-10-01 18:46:32.000000000 -0700
+++ ns-3.47/src/spectrum/test/three-gpp-channel-test-suite.cc	2026-02-16 16:08:49.826230800 -0800
@@ -488,6 +507,469 @@
 /**
  * @ingroup spectrum-tests
  *
+ * Test case for channel consistency Procedure A (according to 3GPP 38.901 Section 7.6.3.)
+ *
+ * This test verifies that the consistent channel updates produce smoother changes in the channel
+ * matrix than generating a completely new channel. The test checks both channel condition LOS and
+ * NLOS. This is very important because, according to the Procedure A, the per-cluster variables
+ * updates are performed differently for LOS and NLOS. For example, there are different formulas for
+ * different channel conditions for cluster delay update (eq. 7.6-9) and cluster departure/arrival
+ * angles (eq. 7.6-10b and 7.6-10c). The test allows configuring different speeds and frequencies.
+ * Based on these parameters is calculated the channel coherence time and the channel update period
+ * is set based on this value.
+ *
+ * The test verifies that the evolution of the general metric like the Frobenius channel norm, and
+ * per-cluster variables such as cluster delay, cluster power, and cluster angles (AOA and ZOA) is
+ * smoother with channel updates than with the new channel realizations. For the cluster metrics is
+ * selected the third cluster as defined in Table 7.8.5 for the calibration of the channel
+ * consistency.
+ *
+ * The test checks that the channel consistent updates according 3GPP 38.901 Procedure A result in a
+ * channel that evolves more smoothly than generating a completely new channel. Variations are at
+ * least 5 times lower than these of new channel realizations.
+ *
+ * To be able to get the results not only for the updated channel but also for the new channel
+ * realizations, we create new nodes that are tracking the update positions of the original node for
+ * which the channel updates are being generated. New nodes are forcing new channel realizations.
+ */
+class ThreeGppChannelConsistencyTest : public TestCase
+{
+  public:
+    /**
+     *Constructor
+     */
+    ThreeGppChannelConsistencyTest(ChannelCondition::LosConditionValue losCondition,
+                                   double speedKmh,
+                                   double freqHz);
+
+    /**
+     * Destructor
+     */
+    ~ThreeGppChannelConsistencyTest() override;
+
+    /**
+     * ChannelConsistencyMetrics structure contains the metrics that are needed to test the channel
+     * consistency.
+     */
+    struct ChannelConsistencyMetrics
+    {
+        //! the channel norm value
+        double channelNorm;
+        //! the third cluster power in dB
+        double thirdClusterPower_dB;
+        //! the third cluster delay
+        double thirdClusterDelay;
+        //! the third cluster AOA
+        double thirdClusterAoa;
+        //! the third cluster ZOA
+        double thirdClusterZoa;
+
+        /**
+         * Operator + for easier calculations of the other metrics (e.g., mean values).
+         * @param other the other object of ChannelConsistencyMetrics
+         * @return the sum of the metrics
+         */
+        ChannelConsistencyMetrics operator+(const ChannelConsistencyMetrics& other) const
+        {
+            return ChannelConsistencyMetrics{channelNorm + other.channelNorm,
+                                             thirdClusterPower_dB + other.thirdClusterPower_dB,
+                                             thirdClusterDelay + other.thirdClusterDelay,
+                                             thirdClusterAoa + other.thirdClusterAoa,
+                                             thirdClusterZoa + other.thirdClusterZoa};
+        }
+
+        /**
+         * Operator += for easier calculations of the other metrics (e.g., mean)
+         * @param other the other object of the  channel consistency metrics
+         * @return the sum of the metrics
+         */
+        ChannelConsistencyMetrics operator+=(const ChannelConsistencyMetrics& other)
+        {
+            this->channelNorm = this->channelNorm + other.channelNorm;
+            this->thirdClusterPower_dB = this->thirdClusterPower_dB + other.thirdClusterPower_dB;
+            this->thirdClusterDelay = this->thirdClusterDelay + other.thirdClusterDelay;
+            this->thirdClusterAoa = this->thirdClusterAoa + other.thirdClusterAoa;
+            this->thirdClusterZoa = this->thirdClusterZoa + other.thirdClusterZoa;
+            return *this;
+        }
+
+        /**
+         * Operator / used for easier calculations of the statistics, and test conditions.
+         * @param iterations The value with which will be divided each metric.
+         * @return the new object with the metrics that are divided by the given value.
+         */
+        ChannelConsistencyMetrics operator/(double iterations) const
+        {
+            ChannelConsistencyMetrics result;
+            result.channelNorm = this->channelNorm / iterations;
+            result.thirdClusterPower_dB = this->thirdClusterPower_dB / iterations;
+            result.thirdClusterDelay = this->thirdClusterDelay / iterations;
+            result.thirdClusterAoa = this->thirdClusterAoa / iterations;
+            result.thirdClusterZoa = this->thirdClusterZoa / iterations;
+            return result;
+        }
+
+        /**
+         * Operator /= used for easier calculations of the statistics, and test conditions.
+         * @param iterations The value with which will be divided each metric.
+         * @return the new object with the metrics that are divided by the given value.s
+         */
+        ChannelConsistencyMetrics operator/=(double iterations)
+        {
+            *this = *this / iterations;
+            return *this;
+        }
+
+        /**
+         *Used for easier calculations of the statistics, and test conditions.
+         *@return the new object with the absolute values of all the metrics
+         */
+        ChannelConsistencyMetrics abs() const
+        {
+            return ChannelConsistencyMetrics{std::abs(channelNorm),
+                                             std::abs(thirdClusterPower_dB),
+                                             std::abs(thirdClusterDelay),
+                                             std::abs(thirdClusterAoa),
+                                             std::abs(thirdClusterZoa)};
+        }
+
+        /**
+         * Used for checking the channel consistency test condition.
+         * @param other the values of the object containing the set of consistency metric
+         * @return true if the metrics of this object have lower values than these of the other
+         * object
+         */
+        bool operator<(const ChannelConsistencyMetrics& other) const
+        {
+            return (this->channelNorm < other.channelNorm) &&
+                   (this->thirdClusterPower_dB < other.thirdClusterPower_dB) &&
+                   (this->thirdClusterDelay < other.thirdClusterDelay) &&
+                   (this->thirdClusterAoa < other.thirdClusterAoa) &&
+                   (this->thirdClusterZoa < other.thirdClusterZoa);
+        }
+    };
+
+    /**
+     * Used for the calculation of the delta of all the metrics between 2 channel consistency metric
+     * objects. Returns a new object containing these delta values for each of the metrics.
+     * @param metrics1 The first channel consistency metrics object.
+     * @param metrics2 The second channel consistency metrics object.
+     * @return The channel consistency object containing the deltas of each of the metrics between
+     * the first and the second object.
+     */
+    ChannelConsistencyMetrics ComputeDeltas(ChannelConsistencyMetrics metrics1,
+                                            ChannelConsistencyMetrics metrics2)
+    {
+        ChannelConsistencyMetrics deltas;
+        deltas.channelNorm = metrics1.channelNorm - metrics2.channelNorm;
+        deltas.thirdClusterPower_dB = metrics1.thirdClusterPower_dB - metrics2.thirdClusterPower_dB;
+        deltas.thirdClusterDelay = metrics1.thirdClusterDelay - metrics2.thirdClusterDelay;
+        deltas.thirdClusterAoa = metrics1.thirdClusterAoa - metrics2.thirdClusterAoa;
+        deltas.thirdClusterZoa = metrics1.thirdClusterZoa - metrics2.thirdClusterZoa;
+        return deltas;
+    }
+
+  private:
+    /**
+     * Build the test scenario
+     */
+    void DoRun() override;
+
+    /**
+     * Compute the channel consistency metrics to evaluate the varying rate of general channel
+     * metrics like:
+     *    - Frobenius norm of the channel matrix and stores it in m_normVector, and per-cluster
+     * metrics like:
+     *    - Cluster power (of the third cluster as per Table 7.8.5 from 38.901 for the calibration
+     * of the channel consistency)
+     *    - Cluster delay (of the third cluster as per Table 7.8.5 from 38.901 for the calibration
+     * of the channel consistency)
+     *    - Cluster AOA and ZOA (of the third cluster as per Table 7.8.5 from 38.901 for the
+     * calibration of the channel consistency)
+     *
+     * @param channelModel the ThreeGppChannelModel object used to generate the channel matrix
+     * @param txMob the mobility model of the first node
+     * @param rxMob the mobility model of the second node
+     * @param txAntenna the antenna object associated to the first node
+     * @param rxAntenna the antenna object associated to the second node
+     * @param metricsVectorToBeUsed the metrics vector to be used as the output of the function
+     * @param distancesVectorToBeUsed the metrics distances vector to be used as the output of the
+     * function
+     */
+    void DoComputeConsistencyMetrics(
+        Ptr<ThreeGppChannelModel> channelModel,
+        Ptr<MobilityModel> txMob,
+        Ptr<MobilityModel> rxMob,
+        Ptr<PhasedArrayModel> txAntenna,
+        Ptr<PhasedArrayModel> rxAntenna,
+        std::vector<ChannelConsistencyMetrics>* metricsVectorToBeUsed,
+        std::vector<ChannelConsistencyMetrics>* distancesVectorToBeUsed);
+
+    //! consistency metrics for the channel updates
+    std::vector<ChannelConsistencyMetrics> m_consistencyMetricsChannelUpdates;
+    //! consistency metrics for the new channel realizations
+    std::vector<ChannelConsistencyMetrics> m_consistencyMetricsNewChannelRealizations;
+    //! consistency metric deltas for the channel updates
+    std::vector<ChannelConsistencyMetrics> m_consistencyMetricsDeltasChannelUpdates;
+    //! consistency metric deltas for the new channel realizations
+    std::vector<ChannelConsistencyMetrics> m_consistencyMetricsDeltasNewChannelRealizations;
+
+    uint32_t m_txAntennaElements{4}; //!< number of rows and columns of tx antenna array
+    uint32_t m_rxAntennaElements{4}; //!< number of rows and columns of rx antenna array
+    //! The type of channel condition to be set; can be LOS or NLOS
+    ChannelCondition::LosConditionValue m_losCondition{ChannelCondition::LOS};
+    //! The speed of the user to be used in the test case
+    double m_speedKmh{30.0};
+    //! The carrier frequency to be used in the test case
+    double m_freqHz{4.0e9};
+};
+
+/**
+ * ThreeGppChannelConsistency constructor
+ * @param losCondition the LOS condition to be used in the test setup
+ * @param speedKmh the speed of the user to be used in the test setup
+ * @param freqHz the central carrier frequency to be used in the test setup
+ */
+ThreeGppChannelConsistencyTest::ThreeGppChannelConsistencyTest(
+    ChannelCondition::LosConditionValue losCondition,
+    double speedKmh,
+    double freqHz)
+    : TestCase(std::string("Check the channel consistency feature for losCondition ") +
+               ((losCondition == ChannelCondition::LOS) ? "LOS" : "NLOS") +
+               ", speed=" + std::to_string(speedKmh) +
+               " kmph, and freq=" + std::to_string(freqHz / 1e9) + " GHz.")
+{
+    m_losCondition = losCondition;
+    m_speedKmh = speedKmh;
+    m_freqHz = freqHz;
+}
+
+ThreeGppChannelConsistencyTest::~ThreeGppChannelConsistencyTest()
+{
+}
+
+void
+ThreeGppChannelConsistencyTest::DoComputeConsistencyMetrics(
+    Ptr<ThreeGppChannelModel> channelModel,
+    Ptr<MobilityModel> txMob,
+    Ptr<MobilityModel> rxMob,
+    Ptr<PhasedArrayModel> txAntenna,
+    Ptr<PhasedArrayModel> rxAntenna,
+    std::vector<ChannelConsistencyMetrics>* metricsVectorToBeUsed,
+    std::vector<ChannelConsistencyMetrics>* distancesVectorToBeUsed)
+{
+    uint64_t txAntennaElements = txAntenna->GetNumElems();
+    uint64_t rxAntennaElements = rxAntenna->GetNumElems();
+
+    Ptr<const ThreeGppChannelModel::ChannelMatrix> channelMatrix =
+        channelModel->GetChannel(txMob, rxMob, txAntenna, rxAntenna);
+
+    double channelNorm = 0;
+    uint16_t numTotalClusters = channelMatrix->m_channel.GetNumPages();
+    for (uint16_t cIndex = 0; cIndex < numTotalClusters; cIndex++)
+    {
+        double clusterNorm = 0;
+        for (uint64_t sIndex = 0; sIndex < txAntennaElements; sIndex++)
+        {
+            for (uint64_t uIndex = 0; uIndex < rxAntennaElements; uIndex++)
+            {
+                clusterNorm +=
+                    std::pow(std::abs(channelMatrix->m_channel(uIndex, sIndex, cIndex)), 2);
+            }
+        }
+        channelNorm += clusterNorm;
+    }
+
+    Ptr<const MatrixBasedChannelModel::ChannelParams> baseParams =
+        channelModel->GetParams(txMob, rxMob);
+    Ptr<const ThreeGppChannelModel::ThreeGppChannelParams> channelParams =
+        DynamicCast<const ThreeGppChannelModel::ThreeGppChannelParams>(baseParams);
+
+    double thirdClusterPower_dB = std::numeric_limits<double>::quiet_NaN();
+    // delay of the third cluster
+    double thirdClusterDelay = std::numeric_limits<double>::quiet_NaN();
+    // AOA of the third cluster
+    double thirdClusterAoa = std::numeric_limits<double>::quiet_NaN();
+    // ZOA of the third cluster
+    double thirdClusterZoa = std::numeric_limits<double>::quiet_NaN();
+
+    if (channelParams->m_clusterPower.size() > 2)
+    {
+        uint8_t thirdClusterIndex = 2; // the index of the third cluster
+        thirdClusterPower_dB = 10 * log10(channelParams->m_clusterPower.at(thirdClusterIndex));
+        // delay of the third cluster
+        thirdClusterDelay = channelParams->m_delay.at(thirdClusterIndex);
+        // AOA of the third cluster
+        thirdClusterAoa = channelParams->m_angle.at(0).at(thirdClusterIndex);
+        // ZOA of the third cluster
+        thirdClusterZoa = channelParams->m_angle.at(1).at(thirdClusterIndex);
+    }
+
+    metricsVectorToBeUsed->push_back(
+        {channelNorm, thirdClusterPower_dB, thirdClusterDelay, thirdClusterAoa, thirdClusterZoa});
+
+    if (metricsVectorToBeUsed->size() > 1)
+    {
+        ChannelConsistencyMetrics deltas =
+            ComputeDeltas(metricsVectorToBeUsed->at(metricsVectorToBeUsed->size() - 2),
+                          metricsVectorToBeUsed->at(metricsVectorToBeUsed->size() - 1));
+        // we calculate the absolute value of the difference between the last two norms
+        distancesVectorToBeUsed->push_back(deltas);
+    }
+}
+
+void
+ThreeGppChannelConsistencyTest::DoRun()
+{
+    RngSeedManager::SetSeed(1);
+    RngSeedManager::SetRun(1);
+    double speedMps = m_speedKmh * 1000 / 3600;
+    // calculate doppler spread
+    double fDoppler = (speedMps * m_freqHz) / 3e8;
+    // calculate channel coherence time
+    Time cTime = Seconds(1 / fDoppler);
+    // set update period
+    const Time& updatePeriod = cTime;
+
+    uint16_t iterations = 100;
+    m_consistencyMetricsChannelUpdates.reserve(iterations);
+    m_consistencyMetricsNewChannelRealizations.reserve(iterations);
+    m_consistencyMetricsDeltasChannelUpdates.reserve(iterations - 1);
+    m_consistencyMetricsDeltasNewChannelRealizations.reserve(iterations - 1);
+
+    // create the channel condition model
+    Ptr<ChannelConditionModel> channelConditionModel;
+
+    if (m_losCondition == ChannelCondition::LOS)
+    {
+        channelConditionModel = CreateObject<AlwaysLosChannelConditionModel>();
+    }
+    else
+    {
+        channelConditionModel = CreateObject<NeverLosChannelConditionModel>();
+    }
+
+    // create the ThreeGppChannelModel object used to generate the channel matrix
+    Ptr<ThreeGppChannelModel> channelModel = CreateObject<ThreeGppChannelModel>();
+    channelModel->SetAttribute("Frequency", DoubleValue(m_freqHz));
+    channelModel->SetAttribute("Scenario", StringValue("RMa"));
+    channelModel->SetAttribute("ChannelConditionModel", PointerValue(channelConditionModel));
+    channelModel->SetAttribute("UpdatePeriod", TimeValue(updatePeriod));
+    channelModel->AssignStreams(1);
+
+    // create the tx and rx nodes
+    NodeContainer nodeTx;
+    NodeContainer nodeRx;
+    NodeContainer nodesRxOther;
+    // we compare the channel update between the TX1 and RX1, and the independent channel
+    // generations between the same TX and 100 different RX that are at the time instant of the
+    // channel generation at the same position as the RX1
+    nodeTx.Create(1);
+    nodeRx.Create(1);
+    nodesRxOther.Create(100);
+
+    // create the tx and rx mobility models and set their positions
+    Ptr<MobilityModel> txMob = CreateObject<ConstantPositionMobilityModel>();
+    txMob->SetPosition(Vector(0.0, 0.0, 10.0));
+    Ptr<ConstantVelocityMobilityModel> rxMob = CreateObject<ConstantVelocityMobilityModel>();
+    rxMob->SetPosition(Vector(30.0, 0.0, 1.0));
+    rxMob->SetVelocity(Vector(speedMps, 0, 0));
+
+    // associate the nodes and the mobility models
+    nodeTx.Get(0)->AggregateObject(txMob);
+    nodeRx.Get(0)->AggregateObject(rxMob);
+
+    std::vector<Ptr<ConstantVelocityMobilityModel>> rxMobCopies{100};
+    rxMobCopies.reserve(100);
+
+    for (uint32_t i = 0; i < 100; i++)
+    {
+        Ptr<ConstantVelocityMobilityModel> rxMobCopy =
+            CreateObject<ConstantVelocityMobilityModel>();
+        rxMobCopy->SetPosition(Vector(30.0, 0.0, 1.0));
+        rxMobCopy->SetVelocity(Vector(speedMps, 0, 0));
+        nodesRxOther.Get(i)->AggregateObject(rxMobCopy);
+        rxMobCopies[i] = rxMobCopy;
+    }
+
+    // create the tx and rx antennas and set the their dimensions
+    Ptr<PhasedArrayModel> txAntenna = CreateObjectWithAttributes<UniformPlanarArray>(
+        "NumColumns",
+        UintegerValue(m_txAntennaElements),
+        "NumRows",
+        UintegerValue(m_txAntennaElements),
+        "AntennaElement",
+        PointerValue(CreateObject<IsotropicAntennaModel>()),
+        "BearingAngle",
+        DoubleValue(0));
+
+    Ptr<PhasedArrayModel> rxAntenna = CreateObjectWithAttributes<UniformPlanarArray>(
+        "NumColumns",
+        UintegerValue(m_rxAntennaElements),
+        "NumRows",
+        UintegerValue(m_rxAntennaElements),
+        "AntennaElement",
+        PointerValue(CreateObject<IsotropicAntennaModel>()),
+        "BearingAngle",
+        DoubleValue(M_PI));
+
+    // test if the channel matrix is correctly updated
+    for (uint16_t i = 0; i < iterations; i++)
+    {
+        Simulator::Schedule(updatePeriod * i + NanoSeconds(1),
+                            &ThreeGppChannelConsistencyTest::DoComputeConsistencyMetrics,
+                            this,
+                            channelModel,
+                            txMob,
+                            rxMob,
+                            txAntenna,
+                            rxAntenna,
+                            &m_consistencyMetricsChannelUpdates,
+                            &m_consistencyMetricsDeltasChannelUpdates);
+
+        Simulator::Schedule(updatePeriod * i + NanoSeconds(1),
+                            &ThreeGppChannelConsistencyTest::DoComputeConsistencyMetrics,
+                            this,
+                            channelModel,
+                            txMob,
+                            rxMobCopies[i],
+                            txAntenna,
+                            rxAntenna,
+                            &m_consistencyMetricsNewChannelRealizations,
+                            &m_consistencyMetricsDeltasNewChannelRealizations);
+    }
+
+    Simulator::Run();
+
+    // compute the sample mean of the channel updates
+    ChannelConsistencyMetrics metricMeanChannelUpdates =
+        m_consistencyMetricsDeltasChannelUpdates.at(0).abs();
+    ChannelConsistencyMetrics metricMeanNewChannelRealizations =
+        m_consistencyMetricsDeltasNewChannelRealizations.at(0).abs();
+
+    for (auto i : m_consistencyMetricsDeltasChannelUpdates)
+    {
+        metricMeanChannelUpdates += i.abs();
+    }
+    metricMeanChannelUpdates /= m_consistencyMetricsDeltasChannelUpdates.size();
+
+    for (auto i : m_consistencyMetricsDeltasNewChannelRealizations)
+    {
+        metricMeanNewChannelRealizations += i.abs();
+    }
+    metricMeanNewChannelRealizations /= m_consistencyMetricsDeltasNewChannelRealizations.size();
+
+    NS_TEST_ASSERT_MSG_EQ(metricMeanChannelUpdates < metricMeanNewChannelRealizations / 5,
+                          true,
+                          "Check that the average distances between the consistency metrics of "
+                          "the consecutive channel updates "
+                          " are lower than of the consecutive new channel generations.");
+    Simulator::Destroy();
+}
+
+/**
+ * @ingroup spectrum-tests
+ *
  * Test case for the ThreeGppChannelModel class.
  * It checks if the channel realizations are correctly
  * updated after a change in the number of antenna elements.
@@ -590,16 +1072,6 @@
     NodeContainer nodes;
     nodes.Create(2);
 
-    // create the tx and rx devices
-    Ptr<SimpleNetDevice> txDev = CreateObject<SimpleNetDevice>();
-    Ptr<SimpleNetDevice> rxDev = CreateObject<SimpleNetDevice>();
-
-    // associate the nodes and the devices
-    nodes.Get(0)->AddDevice(txDev);
-    txDev->SetNode(nodes.Get(0));
-    nodes.Get(1)->AddDevice(rxDev);
-    rxDev->SetNode(nodes.Get(1));
-
     // create the tx and rx mobility models and set their positions
     Ptr<MobilityModel> txMob = CreateObject<ConstantPositionMobilityModel>();
     txMob->SetPosition(Vector(0.0, 0.0, 10.0));
@@ -727,8 +1199,10 @@
     Ptr<MobilityModel> txMob;               //!< the mobility model of the tx device
     Ptr<MobilityModel> rxMob;               //!< the mobility model of the rx device
     Ptr<SpectrumValue> rxPsdOld;            //!< the previously received PSD
-    Ptr<PhasedArrayModel> txAntenna;        //!< the antenna array of the tx device
-    Ptr<PhasedArrayModel> rxAntenna;        //!< the antenna array of the rx device
+    Ptr<const ComplexMatrixArray>
+        rxSpectrumChannelMatrix;     //!< the spectrum channel matrix of the received signal
+    Ptr<PhasedArrayModel> txAntenna; //!< the antenna array of the tx device
+    Ptr<PhasedArrayModel> rxAntenna; //!< the antenna array of the rx device
 };
 
 /**
@@ -771,29 +1245,39 @@
     void DoRun() override;
 
     /**
-     * Points the beam of thisDevice towards otherDevice
-     * @param thisDevice the device to configure
+     * Perform beamforming from this node towards the other node
+     * @param thisMob the mobility model of this device
      * @param thisAntenna the antenna object associated to thisDevice
-     * @param otherDevice the device to communicate with
-     * @param otherAntenna the antenna object associated to otherDevice
+     * @param otherMob the mobility model of the other device
+     * @param otherAntenna the antenna array object of to otherDevice
      */
-    void DoBeamforming(Ptr<NetDevice> thisDevice,
+    void DoBeamforming(Ptr<MobilityModel> thisMob,
                        Ptr<PhasedArrayModel> thisAntenna,
-                       Ptr<NetDevice> otherDevice,
+                       Ptr<MobilityModel> otherMob,
                        Ptr<PhasedArrayModel> otherAntenna);
 
     /**
-     * Test of the long term component is correctly updated when the channel
-     * matrix is recomputed
+     *  Test of the long-term component is correctly updated when the positions and beamforming
+     * change
+     * @param params a structure that contains the set of parameters needed by
+     * CheckUpdateAfterChangingPositionsAndBeamforming in order to perform calculations
+     */
+    void CheckUpdateAfterChangingPositionsAndBeamforming(const CheckLongTermUpdateParams& params);
+
+    /**
+     * Test of the long-term component is correctly updated when the update period expires.
+     * This function slightly moves the position of the tx node to allow the update to be performed.
      * @param params a structure that contains the set of parameters needed by CheckLongTermUpdate
      * in order to perform calculations
      */
-    void CheckLongTermUpdate(const CheckLongTermUpdateParams& params);
+    void CheckLongTermUpdate(CheckLongTermUpdateParams& params);
 
     uint32_t m_txAntennaElements{4}; //!< number of rows and columns of tx antenna array
     uint32_t m_rxAntennaElements{4}; //!< number of rows and columns of rx antenna array
     uint32_t m_txPorts{1}; //!< number of horizontal and vertical ports of tx antenna array
     uint32_t m_rxPorts{1}; //!< number of horizontal and vertical ports of rx antenna array
+    //! used as the input for the long-term update check after the update period expires
+    Ptr<SpectrumSignalParameters> m_rxParamsOld;
 };
 
 ThreeGppSpectrumPropagationLossModelTest::ThreeGppSpectrumPropagationLossModelTest(
@@ -814,13 +1298,13 @@
 }
 
 void
-ThreeGppSpectrumPropagationLossModelTest::DoBeamforming(Ptr<NetDevice> thisDevice,
+ThreeGppSpectrumPropagationLossModelTest::DoBeamforming(Ptr<MobilityModel> thisMob,
                                                         Ptr<PhasedArrayModel> thisAntenna,
-                                                        Ptr<NetDevice> otherDevice,
+                                                        Ptr<MobilityModel> otherMob,
                                                         Ptr<PhasedArrayModel> otherAntenna)
 {
-    Vector aPos = thisDevice->GetNode()->GetObject<MobilityModel>()->GetPosition();
-    Vector bPos = otherDevice->GetNode()->GetObject<MobilityModel>()->GetPosition();
+    Vector aPos = thisMob->GetPosition();
+    Vector bPos = otherMob->GetPosition();
 
     // compute the azimuth and the elevation angles
     Angles completeAngle(bPos, aPos);
@@ -831,15 +1315,43 @@
 }
 
 void
-ThreeGppSpectrumPropagationLossModelTest::CheckLongTermUpdate(
+ThreeGppSpectrumPropagationLossModelTest::CheckUpdateAfterChangingPositionsAndBeamforming(
     const CheckLongTermUpdateParams& params)
 {
+    // Reciprocity check: evaluate reverse direction after changing positions/beamforming.
+    auto rxPsdNewParams = params.lossModel->DoCalcRxPowerSpectralDensity(params.txParams,
+                                                                         params.rxMob,
+                                                                         params.txMob,
+                                                                         params.rxAntenna,
+                                                                         params.txAntenna);
+
+    NS_TEST_ASSERT_MSG_EQ((*params.rxPsdOld == *rxPsdNewParams->psd),
+                          false,
+                          "Changing the positions and BF vectors the rx PSD does not change");
+
+    NS_TEST_ASSERT_MSG_EQ(
+        (*params.rxSpectrumChannelMatrix == *rxPsdNewParams->spectrumChannelMatrix),
+        false,
+        "Changing the BF should change de frequency domain channel matrix");
+
+    m_rxParamsOld = rxPsdNewParams;
+}
+
+void
+ThreeGppSpectrumPropagationLossModelTest::CheckLongTermUpdate(CheckLongTermUpdateParams& params)
+{
+    // we need to slightly move the node to allow the channel to be updated upon the update period,
+    // but less than 1 meter, which would trigger new channel generation
+    params.txMob->SetPosition(Vector(params.txMob->GetPosition().x + 0.1,
+                                     params.txMob->GetPosition().y,
+                                     params.txMob->GetPosition().z));
+
     auto rxPsdNewParams = params.lossModel->DoCalcRxPowerSpectralDensity(params.txParams,
                                                                          params.txMob,
                                                                          params.rxMob,
                                                                          params.txAntenna,
                                                                          params.rxAntenna);
-    NS_TEST_ASSERT_MSG_EQ((*params.rxPsdOld == *rxPsdNewParams->psd),
+    NS_TEST_ASSERT_MSG_EQ((*m_rxParamsOld->psd == *rxPsdNewParams->psd),
                           false,
                           "The long term is not updated when the channel matrix is recomputed");
 }
@@ -869,16 +1381,6 @@
     NodeContainer nodes;
     nodes.Create(2);
 
-    // create the tx and rx devices
-    Ptr<SimpleNetDevice> txDev = CreateObject<SimpleNetDevice>();
-    Ptr<SimpleNetDevice> rxDev = CreateObject<SimpleNetDevice>();
-
-    // associate the nodes and the devices
-    nodes.Get(0)->AddDevice(txDev);
-    txDev->SetNode(nodes.Get(0));
-    nodes.Get(1)->AddDevice(rxDev);
-    rxDev->SetNode(nodes.Get(1));
-
     // create the tx and rx mobility models and set their positions
     Ptr<MobilityModel> txMob = CreateObject<ConstantPositionMobilityModel>();
     txMob->SetPosition(Vector(0.0, 0.0, 10.0));
@@ -895,7 +1397,7 @@
         "NumColumns",
         UintegerValue(m_txAntennaElements),
         "NumRows",
-        UintegerValue(m_rxAntennaElements),
+        UintegerValue(m_txAntennaElements),
         "AntennaElement",
         PointerValue(CreateObject<IsotropicAntennaModel>()),
         "NumVerticalPorts",
@@ -916,8 +1418,8 @@
         UintegerValue(m_rxPorts));
 
     // set the beamforming vectors
-    DoBeamforming(txDev, txAntenna, rxDev, rxAntenna);
-    DoBeamforming(rxDev, rxAntenna, txDev, txAntenna);
+    DoBeamforming(txMob, txAntenna, rxMob, rxAntenna);
+    DoBeamforming(rxMob, rxAntenna, txMob, txAntenna);
 
     // create the tx psd
     SpectrumValue5MhzFactory sf;
@@ -931,7 +1433,7 @@
     auto rxParamsOld =
         lossModel->DoCalcRxPowerSpectralDensity(txParams, txMob, rxMob, txAntenna, rxAntenna);
 
-    // 1) check that the rx PSD is equal for both the direct and the reverse channel
+    // 1) check reciprocity: rx PSD is equal for both the direct and the reverse channel
     auto rxParamsNew =
         lossModel->DoCalcRxPowerSpectralDensity(txParams, rxMob, txMob, rxAntenna, txAntenna);
     if ((rxParamsOld->spectrumChannelMatrix->GetNumCols() ==
